<?php

require __DIR__.'/vendor/autoload.php';
require __DIR__.'/vendor/zeedhi/framework/bootstrap.php';
require __DIR__ . '/vendor/teknisa/libraries-next/scripts/bootstrap.php';

$instanceManager = \Zeedhi\Framework\DependencyInjection\InstanceManager::getInstance();

$db              = __DIR__.'/../../../backend/config/db.xml';
$general         = __DIR__.'/../../../backend/config/general.xml';
$environment     = __DIR__.'/config/environment.xml';
$parameters      = __DIR__.'/config/parameters.xml';
$parametersProd  = __DIR__.'/../../../backend/config/parameters.xml';
$report          = __DIR__.'/config/report.xml';

if(!realpath($db)) {
    $db = __DIR__."/config/db.xml";
}

$routes = array();
$routes[] = __DIR__ . '/vendor/teknisa/libraries-next/libRoutes.json';

$mapping = file_get_contents(__DIR__.'/config/servicesMapping.json');
$mapping = json_decode($mapping, true);

foreach ($mapping as $path) {
    $ext = substr(strrchr($path,'.'),1);
    if($ext === 'xml')
        $instanceManager->loadFromFile(__DIR__.$path);
    elseif($ext === 'json')
        $routes[] = __DIR__.$path;
}

$instanceManager->loadFromFile($db);
// $instanceManager->loadFromFile($general);
// $instanceManager->loadFromFile($report);
$instanceManager->loadFromFile($parametersProd);
$instanceManager->loadFromFile($parameters);
$instanceManager->loadFromFile($environment);

$container = $instanceManager->getContainer();


$instanceManager->registerService('routeParser', new \Zeedhi\Framework\Routing\Parsers\JSONFormat($routes));

$instanceManager->compile();

use Doctrine\DBAL\Types\Type;

$entity_manager = $instanceManager->getService('entityManager');
\Setforms2\Shared\Registry::store("EntityManager", $entity_manager);
\Setforms2\Shared\Registry::store("EntityManagerConnection", $entity_manager->getConnection());