<?php
namespace Teknisa\CDP\Factories;

use Doctrine\ORM\EntityManager; 
use Zeedhi\Framework\DependencyInjection\InstanceManager;

class AtividadeAppFactory {
    
    //protected $connectionCustom;
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager    = $entityManager;
        // if(InstanceManager::getInstance()->getService('EntityManager')->getConnection()->getParams()['useVpd']){
            //$newEntityManager = $connectionCustom->updateVpdConnection('2897');
            // $this->connection = $newEntityManager->getConnection();
        // }else{
            $this->connection = $entityManager->getConnection();
        // }
        //$this->connectionCustom = $connectionCustom;
    }
    
    public function isCompleted($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $IDSITGRAVCONT, $nrorg){
        $IDSITGRAVCONT = 'C';
        try {
        
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "SELECT *
                    FROM RECURETAPAOP 
                   WHERE CDFILIAL      = :CDFILIAL
                     AND NRAUDITORIA   = :NRAUDITORIA
                     AND NRINSPECAUDI  = :NRINSPECAUDI 
                     AND NRRECUETAPOP  = :NRRECUETAPOP
                     AND IDSITGRAVCONT = :IDSITGRAVCONT
                     AND NRORG         = :NRORG 
                     AND DTFINUTRECOP IS NOT NULL";

            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'IDSITGRAVCONT'=>$IDSITGRAVCONT,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
        
    }  
    
    public function inProgress($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $nrorg){
        try {
         
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
         
            $sql = "SELECT *
                    FROM RECURETAPAOP 
                   WHERE CDFILIAL     = :CDFILIAL
                     AND NRAUDITORIA  = :NRAUDITORIA
                     AND NRINSPECAUDI = :NRINSPECAUDI 
                     AND NRRECUETAPOP = :NRRECUETAPOP
                     AND NRORG        = :NRORG 
                     AND DTINIUTRECOP IS NOT NULL";

            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
        
    }
    
    public function isPending($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $IDSITGRAVCONT, $nrorg){
        $IDSITGRAVCONT = 'P';
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "SELECT *
                    FROM RECURETAPAOP 
                   WHERE CDFILIAL      = :CDFILIAL
                     AND NRAUDITORIA   = :NRAUDITORIA
                     AND NRINSPECAUDI  = :NRINSPECAUDI 
                     AND NRRECUETAPOP  = :NRRECUETAPOP
                     AND NRORG         = :NRORG 
                     AND IDSITGRAVCONT = :IDSITGRAVCONT
                     AND DTINIUTRECOP  IS NOT NULL";
                     
            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'IDSITGRAVCONT'=>$IDSITGRAVCONT,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
        
    }
    
    public function isTheFirst($cdfilial, $nrauditoria, $nrinspecaudi, $nrorg){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "SELECT count(*) as COUNT
                      FROM RECURETAPAOP
                     WHERE CDFILIAL     = :CDFILIAL
                       AND NRAUDITORIA  = :NRAUDITORIA
                       AND NRINSPECAUDI = :NRINSPECAUDI  
                       AND DTINIUTRECOP IS NOT NULL
                       AND NRORG        = :NRORG";
                     
            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function initTask($DTINIRINSAUD, $cdfilial, $nrauditoria, $nrinspecaudi, $cdoperador){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "UPDATE INSPECAUDIT
                          SET DTINIRINSAUD = :DTINIRINSAUD,
                          CDOPERADOR       = :CDOPERADOR 
                        WHERE CDFILIAL     = :CDFILIAL    
                          AND NRAUDITORIA  = :NRAUDITORIA 
                          AND NRINSPECAUDI = :NRINSPECAUDI";
                     
            $params = array(
                'DTINIRINSAUD'=>$DTINIRINSAUD,
                'CDOPERADOR'=>$cdoperador,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function initActivity($DTINIUTRECOP, $cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $nrorg, $cdoperador){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "UPDATE RECURETAPAOP 
                      SET DTINIUTRECOP = :DTINIUTRECOP ,
                          CDOPERADOR   = :CDOPERADOR 
                    WHERE CDFILIAL     = :CDFILIAL 
                      AND NRAUDITORIA  = :NRAUDITORIA 
                      AND NRINSPECAUDI = :NRINSPECAUDI 
                      AND NRRECUETAPOP = :NRRECUETAPOP 
                      AND NRORG        = :NRORG";
                     
            $params = array(
                'DTINIUTRECOP'=>$DTINIUTRECOP,
                'CDOPERADOR'=>$cdoperador,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function getTaskDtInit($cdfilial, $nrauditoria, $nrinspecaudi){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "SELECT 
                    (((TO_CHAR(SYSDATE, 'J') * 86400) + (TO_CHAR(SYSDATE, 'SSSSS'))) - ((TO_CHAR(DTINIRINSAUD, 'J') * 86400) + (TO_CHAR(DTINIRINSAUD, 'SSSSS'))))/(60*60) AS DTINIRINSAUD
                        FROM INSPECAUDIT 
                       WHERE CDFILIAL     = :CDFILIAL
                         AND NRAUDITORIA  = :NRAUDITORIA
                         AND NRINSPECAUDI = :NRINSPECAUDI";
                     
            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
 
    public function isTheLast($cdfilial, $nrauditoria, $nrinspecaudi, $nrorg){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "SELECT count(*) as COUNT
                      FROM RECURETAPAOP
                        WHERE CDFILIAL      =  :CDFILIAL
                        AND NRAUDITORIA   =  :NRAUDITORIA
                        AND NRINSPECAUDI  =  :NRINSPECAUDI
                        AND NRRECURPAI IS NULL
                        AND IDSITGRAVCONT <> 'C'
                        AND NRORG         =  :NRORG";
                     
            $params = array(
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function completeTask($DTINIRINSAUD, $SYSDATE, $cdfilial, $nrauditoria, $nrinspecaudi){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "UPDATE INSPECAUDIT
                      SET DTFINRINSAUD = :DTFINRINSAUD,
                          QTHRINSAUD   = :QTHRINSAUD,
                          IDINSPCONC   = 'S'
                    WHERE CDFILIAL     = :CDFILIAL
                      AND NRAUDITORIA  = :NRAUDITORIA
                      AND NRINSPECAUDI = :NRINSPECAUDI";
                     
            $params = array(
                'QTHRINSAUD'=>$DTINIRINSAUD,
                'DTFINRINSAUD'=>$SYSDATE,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function changeStatusAudit($cdfilial, $nrauditoria, $idstatusaudi){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "UPDATE AUDITORIA
                    SET IDSTATUSAUDI    = :P_IDSTATUSAUDI
                    WHERE CDFILIAL      = :P_CDFILIAL 
                    AND NRAUDITORIA     = :P_NRAUDITORIA";
                     
            $params = array(
                'P_CDFILIAL'        => $cdfilial,
                'P_NRAUDITORIA'     => $nrauditoria,
                'P_IDSTATUSAUDI'    => $idstatusaudi
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function completeActivity($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $nrorg, $qttotal, $dtfinal){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "UPDATE RECURETAPAOP 
                        SET IDSITGRAVCONT = 'C',
                            QTHRREARECOP  = :QTHRREARECOP,
                            DTFINUTRECOP  = :DTFINUTRECOP
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG ";
                     
            $params = array(
                'QTHRREARECOP'=>$qttotal,
                'DTFINUTRECOP'=>$dtfinal,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function completeAndPauseActivity($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $nrorg, $qttotal){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "UPDATE RECURETAPAOP 
                        SET IDSITGRAVCONT = 'C',
                        QTHRREARECOP  = :QTHRREARECOP
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG ";
                     
            $params = array(
                'QTHRREARECOP'=>$qttotal,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function completePausedActivity($cdfilial, $nrauditoria, $nrinspecaudi, $nrrecuetapop, $nrorg, $qttotal){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "UPDATE RECURETAPAOP 
                        SET IDSITGRAVCONT = 'C',
                         QTHRREARECOP  = :QTHRREARECOP
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG";
                     
            $params = array(
                'QTHRREARECOP'=>$qttotal,
                'CDFILIAL'=>$cdfilial,
                'NRAUDITORIA'=>$nrauditoria,
                'NRINSPECAUDI'=>$nrinspecaudi,
                'NRRECUETAPOP'=>$nrrecuetapop,
                'NRORG'=>$nrorg
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function pauseActivityFather($row){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "UPDATE RECURETAPAOP 
                        SET IDSITGRAVCONT = 'A'
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function pauseActivity($row){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
           // $this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "UPDATE RECURETAPAOP 
                        SET DTFINUTRECOP  = :DTFINUTRECOP,
                            IDSITGRAVCONT = 'A'
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG";
                     
            $params = array(
                'DTFINUTRECOP'=>$row['PAUSE_DATE'],
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function unpauseActivity($row){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "UPDATE RECURETAPAOP 
                        SET IDSITGRAVCONT = 'P'
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI
                        AND NRRECUETAPOP  = :NRRECUETAPOP
                        AND NRORG         = :NRORG ";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            $return = $this->SELECTmaxNRRECUETAPOP($row);
            return $return;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
     
    public function SELECTmaxNRRECUETAPOPComplete($row){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
           // $this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "SELECT max(NRRECUETAPOP) AS LASTID
                        FROM RECURETAPAOP 
                       WHERE CDFILIAL     = :CDFILIAL
                         AND NRAUDITORIA  = :NRAUDITORIA
                         AND NRINSPECAUDI = :NRINSPECAUDI
                         AND NRORG        = :NRORG 
                         AND CDINSPECAO   = :CDINSPECAO";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'CDINSPECAO'=>$row['CDINSPECAO'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            $result = $std->fetchAll();
            return $result[0]['LASTID'];    
                
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function SELECTmaxNRRECUETAPOP($row){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "SELECT max(NRRECUETAPOP) AS LASTID
                        FROM RECURETAPAOP 
                       WHERE CDFILIAL     = :CDFILIAL
                         AND NRAUDITORIA  = :NRAUDITORIA
                         AND NRINSPECAUDI = :NRINSPECAUDI
                         AND NRORG        = :NRORG 
                         AND CDINSPECAO   = :CDINSPECAO";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'CDINSPECAO'=>$row['CDINSPECAO'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            $result = $std->fetchAll();
            $newNrrecuetapop = intval($result[0]['LASTID']) + 1;
            $zeros = '';
            $toString  = (string)$newNrrecuetapop; 
            for($i=0; $i<(3-strlen($toString));$i++){
               $zeros = $zeros.'0';
            }
            $newNrrecuetapop = $zeros.(string)$newNrrecuetapop;
            $nrpai = $row['NRRECURPAI'] == ''? $row['NRRECUETAPOP'] : $row['NRRECURPAI'];
            $return = $this->buildNewActivity($row, $newNrrecuetapop, $nrpai);
            return $return;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function buildNewActivity($row, $newNrrecuetapop, $nrpai){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "INSERT INTO RECURETAPAOP 
                               (IDSITGRAVCONT, CDFILIAL, NRAUDITORIA, NRINSPECAUDI, NRRECUETAPOP, NRORG, CDINSPECAO, CDHABILIDADE, CDEQUIPPRO, CDOPERADOR, IDRECURETAOP, NRRECURPAI, DTINIUTRECOP)
                                    VALUES (:IDSITGRAVCONT, 
                                            :CDFILIAL, 
                                            :NRAUDITORIA, 
                                            :NRINSPECAUDI, 
                                            :NRRECUETAPOP, 
                                            :NRORG, 
                                            :CDINSPECAO, 
                                            :CDHABILIDADE, 
                                            :CDEQUIPPRO, 
                                            :CDOPERADOR, 
                                            :IDRECURETAOP, 
                                            :NRRECURPAI, 
                                            :DTINIUTRECOP)";
            $params = array(
                'IDSITGRAVCONT'=>'P',
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$newNrrecuetapop,
                'NRORG'=>$row['NRORG'],
                'CDINSPECAO'=>$row['CDINSPECAO'],
                'CDHABILIDADE'=>$row['CDHABILIDADE'],
                'CDEQUIPPRO'=>$row['CDEQUIPPRO'],
                'CDOPERADOR'=>$row['CDOPERADOR'],
                'IDRECURETAOP'=>$row['IDRECURETAOP'],
                'NRRECURPAI'=>$nrpai,
                'DTINIUTRECOP'=>$row['SYSDATE']
            );
            $std = $this->connection->prepare($sql);
            $result = $std->execute($params);
            return $result;
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function searchChild($row){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
           // $this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "SELECT * FROM RECURETAPAOP 
                        WHERE CDFILIAL     = :CDFILIAL 
                            AND NRAUDITORIA  = :NRAUDITORIA 
                            AND NRINSPECAUDI = :NRINSPECAUDI 
                            AND NRRECURPAI = :NRRECUETAPOP 
                            AND NRORG        = :NRORG
                            AND DTFINUTRECOP IS NULL";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
   
    public function searchLastCompleteChild($row){
        try {
            $sql = "SELECT * FROM RECURETAPAOP  
                    WHERE (NRRECUETAPOP = (SELECT MAX(NRRECUETAPOP) FROM RECURETAPAOP 
                          WHERE CDFILIAL     = :CDFILIAL 
                              AND NRAUDITORIA  = :NRAUDITORIA 
                              AND NRINSPECAUDI = :NRINSPECAUDI 
                              AND NRRECURPAI = :NRRECUETAPOP 
                              AND NRORG        = :NRORG
                              AND DTFINUTRECOP IS NOT NULL
                              AND DTINIUTRECOP  IS NOT NULL))
                      AND NRAUDITORIA  = :NRAUDITORIA 
                      AND NRINSPECAUDI = :NRINSPECAUDI 
                      AND NRRECURPAI = :NRRECUETAPOP ";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function lastIDJustificapausa($row){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "SELECT MAX(CDJUSTIFICA) AS LASTID FROM JUSTIFICAPAUSA 
                      WHERE CDFILIAL     = :CDFILIAL 
                      AND NRAUDITORIA  = :NRAUDITORIA 
                      AND NRINSPECAUDI = :NRINSPECAUDI 
                      AND NRRECUETAPOP = :NRRECUETAPOP 
                      AND NRORG        = :NRORG";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            $result = $std->fetchAll();
            if($result[0]['LASTID'] == null){
                $result[0]['LASTID'] = "001";
                return $result;
            } else {
                $LASTID = (intval($result[0]['LASTID']) + 1);
                $zeros = '';
                $toString  = (string)$LASTID; 
                for($i=0; $i<(3-strlen($toString));$i++){
                   $zeros = $zeros.'0';
                }
                $LASTID = $zeros.(string)$LASTID;
                $result[0]['LASTID'] = $LASTID;
                
                return $result;
            }
    
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function sendJustificative($row){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "INSERT INTO JUSTIFICAPAUSA 
                               (CDFILIAL, NRAUDITORIA, NRINSPECAUDI, NRRECUETAPOP, NRORG, CDOPERADOR, CDJUSTIFICA, DSJUSTIFICA, DTPAUSA)
                                    VALUES ( :CDFILIAL, 
                                            :NRAUDITORIA, 
                                            :NRINSPECAUDI, 
                                            :NRRECUETAPOP, 
                                            :NRORG, 
                                            :CDOPERADOR, 
                                            :CDJUSTIFICA, 
                                            :DSJUSTIFICA, 
                                            :DTPAUSA)";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI'],
                'NRRECUETAPOP'=>$row['NRRECUETAPOP'],
                'NRORG'=>$row['NRORG'],
                'CDOPERADOR'=>$row['CDOPERADOR'],
                'CDJUSTIFICA'=>$row['CDJUSTIFICA'],
                'DSJUSTIFICA'=>$row['DSJUSTIFICA'],
                'DTPAUSA'=>$row['DTPAUSA']
            );
            $std = $this->connection->prepare($sql);
            $result = $std->execute($params);
            return $result;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function existeNaTabela($row){
        try {
            $sql = "SELECT * FROM DESCINSAUDIT
                    WHERE CDFILIAL        = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI";
                     
            $params = array(
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI']
            );
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function sendObservacaoInsert($row){
        try {
            $sql = "INSERT INTO DESCINSAUDIT 
                               (TXINSPECAUDI, TEMPINICIAL, TEMPFINAL, PESOINICIAL, PESOFINAL, 
                               CDFILIAL, NRAUDITORIA, NRINSPECAUDI)
                        VALUES (:TXINSPECAUDI, 
                                
                                :TEMPINICIAL,
                                :TEMPFINAL,
                                :PESOINICIAL,
                                :PESOFINAL,
                                
                                :CDFILIAL, 
                                :NRAUDITORIA, 
                                :NRINSPECAUDI)";
                     
            $params = array(
                'TXINSPECAUDI'=>$row['TXINSPECAUDI'],
                
                'TEMPINICIAL'=>$row['TEMPINICIAL'],
                'TEMPFINAL'=>$row['TEMPFINAL'],
                'PESOINICIAL'=>$row['PESOINICIAL'],
                'PESOFINAL'=>$row['PESOFINAL'],
                
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI']
            );
            $std = $this->connection->prepare($sql);
            $result = $std->execute($params);
            return $result;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function sendObservacaoUpdate($row){
        try {
            $sql = "UPDATE DESCINSAUDIT 
                        SET TXINSPECAUDI = :TXINSPECAUDI,
                        TEMPINICIAL = :TEMPINICIAL,
                        TEMPFINAL = :TEMPFINAL,
                        PESOINICIAL = :PESOINICIAL,
                        PESOFINAL = :PESOFINAL
                      WHERE CDFILIAL      = :CDFILIAL
                        AND NRAUDITORIA   = :NRAUDITORIA
                        AND NRINSPECAUDI  = :NRINSPECAUDI";
                     
            $params = array(
                'TXINSPECAUDI'=>$row['TXINSPECAUDI'],
                
                'TEMPINICIAL'=>$row['TEMPINICIAL'],
                'TEMPFINAL'=>$row['TEMPFINAL'],
                'PESOINICIAL'=>$row['PESOINICIAL'],
                'PESOFINAL'=>$row['PESOFINAL'],
                
                'CDFILIAL'=>$row['CDFILIAL'],
                'NRAUDITORIA'=>$row['NRAUDITORIA'],
                'NRINSPECAUDI'=>$row['NRINSPECAUDI']
            );
            $std = $this->connection->prepare($sql);
            $update = $std->execute($params);
            return $update;
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    // public function setNrorgSaas($nrorg){
    //     $useVpd = InstanceManager::getInstance()->getService('EntityManager')->getConnection()->getParams()['useVpd'];
        
    //     if($useVpd){
    //         $newEntityManager = $this->connectionCustom->updateVpdConnection($nrorg);
            
    //         $this->connection = $newEntityManager->getConnection();
    //     }
    // }
    
    public function getOrdens($cdoperador, $nrorg){
        try {
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas($nrorg);
            /* Registra Entitymanager com nrorg do saas */
         
            $sql = "SELECT DISTINCT ET.NRORG,
                            IC.DTINIRINSAUD,
                            IC.DTFINRINSAUD,
                            (CASE WHEN (SYSDATE - TO_DATE(IC.DTINIRINSAUD)) > 3 THEN 'S'
                                 ELSE NULL
                             END) AS DATA_ATUAL,
                            ET.NMETAPAPROD,
                            OP.NRORDPROD,
                            PR.NMPRODUTO,
                            OP.NRORDPROD || ' Prod.: ' || PR.NMPRODUTO AS NAME,
                            OD.NRLOTEESTQ ||' ' ||OD.NRSUBLOTE AS LOTE,
                            OD.NRSUBLOTE,
                            PRE.TMPREVISTO,
                            SUM(REA.TMREAL) TMREAL,
                            OD.IDSITORDPROD,
                            OD.CDFILIAL,
                            ET.CDETAPAPROD,
                            RC.NRAUDITORIA,
                            REA.CDINSPECAO,
                            REA.NRINSPECAUDI,
                            REA.NRPRIORAUDI,
                            INC.NMINSPECAO,
                            OP.NRORDETFABOP,
                            OD.QTAPRODPREOP
                    FROM ETAPAPROD ET,
                         ETAFABRICOP OP,
                         PRODUTO PR,
                         ORDPRODUCAO OD,
                         RECURETAPAOP RC,
                         INSPECAUDIT IC,
                         INSPECAO INC,
                    
                      (SELECT SUM(QTHRINSPEXE) TMPREVISTO,
                              CDFILIAL,
                              CDPRODUTO,
                              CDPROCFABRIC,
                              CDETAPAPROD
                      FROM INSPETAPA
                      GROUP BY CDFILIAL,
                                CDPRODUTO,
                                CDPROCFABRIC,
                                CDETAPAPROD) PRE,
                    
                      (SELECT SUM(I.QTHRINSAUD) AS TMREAL,
                              A.CDFILIAL,
                              A.NRORDPROD,
                              A.NRSUBORDPROD,
                              A.CDETAPAPROD,
                              A.NRAUDITORIA,
                              A.IDORIGAUDIT,
                              I.CDINSPECAO,
                              I.NRINSPECAUDI,
                              A.NRPRIORAUDI
                      FROM AUDITORIA A,
                            INSPECAUDIT I
                      WHERE (I.CDFILIAL = A.CDFILIAL)
                         AND (I.NRAUDITORIA = A.NRAUDITORIA)
                      GROUP BY A.CDFILIAL,
                                A.NRORDPROD,
                                A.NRSUBORDPROD,
                                A.CDETAPAPROD,
                                A.NRAUDITORIA,
                                A.IDORIGAUDIT,
                                I.CDINSPECAO,
                                I.NRINSPECAUDI,
                                A.NRPRIORAUDI) REA
                    WHERE ET.CDETAPAPROD = OP.CDETAPAPROD
                      AND OD.CDPRODUTO = PR.CDPRODUTO
                      AND OD.NRORDPROD = OP.NRORDPROD
                      AND OD.IDSITORDPROD = '2'
                      AND OP.NRSUBORDPROD = OP.NRSUBORDPROD
                      AND OD.CDFILIAL = PRE.CDFILIAL
                      AND OD.CDPRODUTO = PRE.CDPRODUTO
                      AND OD.CDPROCFABRIC = PRE.CDPROCFABRIC
                      AND ET.CDETAPAPROD = PRE.CDETAPAPROD
                      AND REA.CDFILIAL(+) = OP.CDFILIAL
                      AND REA.NRORDPROD(+) = OP.NRORDPROD
                      AND REA.NRSUBORDPROD(+) = OP.NRSUBORDPROD
                      AND REA.CDETAPAPROD(+) = OP.CDETAPAPROD
                      AND RC.NRAUDITORIA = REA.NRAUDITORIA
                      AND RC.CDFILIAL = OP.CDFILIAL
                      AND REA.IDORIGAUDIT = 'TAR'
                      AND RC.NRAUDITORIA = IC.NRAUDITORIA
                      AND OP.CDFILIAL = IC.CDFILIAL
                      AND INC.CDINSPECAO = IC.CDINSPECAO
                      AND ((RC.CDOPERADOR = :CDOPERADOR)
                          OR RC.CDOPERADOR IS NULL)
                      AND :CDOPERADOR IN
                        (SELECT CDOPERADOR
                         FROM HABILOPER
                         WHERE CDHABILIDADE = RC.CDHABILIDADE )
                      AND OD.DTGERORDPROD BETWEEN SYSDATE-50 AND SYSDATE
                    GROUP BY IC.DTINIRINSAUD,
                             IC.DTFINRINSAUD,
                             ET.NMETAPAPROD,
                             OP.NRORDPROD,
                             PR.NMPRODUTO,
                             OD.NRLOTEESTQ ||' ' ||OD.NRSUBLOTE,
                             OD.NRSUBLOTE,
                             PRE.TMPREVISTO,
                             OD.IDSITORDPROD,
                             OD.CDFILIAL,
                             ET.CDETAPAPROD,
                             RC.NRAUDITORIA,
                             REA.CDINSPECAO,
                             REA.NRINSPECAUDI,
                             REA.NRPRIORAUDI,
                             INC.NMINSPECAO,
                             ET.NRORG,
                             OP.NRORDETFABOP,
                             OD.QTAPRODPREOP
                    ORDER BY OP.NRORDPROD DESC,
                             OP.NRORDETFABOP ASC,
                             REA.NRPRIORAUDI ASC";

            $params = array(
                'CDOPERADOR' => $cdoperador
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    }  
    
    public function getTarefas($filter){
        try{
            
            /* Registra Entitymanager com nrorg do saas */
            //$this->setNrorgSaas('2897');
            /* Registra Entitymanager com nrorg do saas */
            
            $sql = "SELECT DISTINCT RE.NRORG,
                                    RE.IDSITGRAVCONT,
                                    RE.NRRECURPAI,
                                    RE.CDFILIAL,
                                    RE.NRAUDITORIA,
                                    RE.NRINSPECAUDI,
                                    RE.NRRECUETAPOP,
                                    RE.CDEQUIPPRO,
                                    RE.CDHABILIDADE,
                                    RE.CDOPERADOR,
                                    RE.DTINIUTRECOP,
                                    RE.DTFINUTRECOP,
                                    RE.QTPRODRECUOP,
                                    RE.QTHRREARECOP,
                                    RE.IDRECURETAOP,
                                    O.NMOPERADOR,
                                    EQ.NMEQUIPPRO,
                                    H.NMHABILIDADE,
                                    RE.NRORDUTRECOP,
                                    RE.IDLIBERECUOP,
                                    A.NRORDPROD,
                                    A.NRSUBORDPROD,
                                    RQ.NRINSPETAPARES,
                                    RE.CDINSPECAO,
                                    A.CDETAPAPROD,
                                    GE.CDGRUPOEQUIPA,
                                    GE.NMGRUPOEQUIPA,
                                    '0000000000' AS CDPRODUTO,
                                    DECODE(RE.IDRECURETAOP, 'E', RE.CDEQUIPPRO, 'H', RE.CDHABILIDADE) AS RECURSO,
                                    DECODE(RE.IDRECURETAOP, 'E', EQ.NMEQUIPPRO, 'H', H.NMHABILIDADE) AS NMRECURSO,
                                    RCE.DIFF_TIME,
                                    IDSITPTCRIT
                    FROM OPERADOR O,
                         EQUIPAPROD EQ,
                         HABILIDADE H,
                         RECURETAPAOP RE,
                         RESERVEQUIPAPRO RQ,
                         GRUPOEQUIPA GE,
                         AUDITORIA A,
                    
                      (SELECT SUM(DIFER_TEMPO) AS DIFF_TIME
                       FROM
                         (SELECT ((TO_CHAR(RCE.DTFINUTRECOP, 'J') * 86400) + (TO_CHAR(RCE.DTFINUTRECOP, 'SSSSS')) + ((TO_CHAR(RCE.DTINIUTRECOP, 'J') * 86400) + (TO_CHAR(RCE.DTINIUTRECOP, 'SSSSS')))*(-1)) AS DIFER_TEMPO
                          FROM RECURETAPAOP RCE,
                               RECURETAPAOP REOP
                          WHERE RCE.CDFILIAL = :CDFILIAL
                            AND RCE.NRAUDITORIA = :NRAUDITORIA
                            AND RCE.NRINSPECAUDI = :NRINSPECAUDI
                            AND ((RCE.NRRECURPAI = REOP.NRRECUETAPOP)
                                 OR (RCE.NRRECUETAPOP = REOP.NRRECUETAPOP))
                            AND RCE.CDFILIAL = REOP.CDFILIAL
                            AND RCE.NRAUDITORIA = REOP.NRAUDITORIA
                            AND RCE.NRINSPECAUDI = REOP.NRINSPECAUDI
                            AND RCE.NRORG = REOP.NRORG
                            AND RCE.DTINIUTRECOP IS NOT NULL
                            AND RCE.DTFINUTRECOP IS NOT NULL
                            AND RCE.DTINIUTRECOP = REOP.DTINIUTRECOP
                            AND RCE.DTFINUTRECOP = REOP.DTFINUTRECOP
                          ORDER BY RCE.NRRECUETAPOP)) RCE
                    WHERE (H.CDHABILIDADE(+) = RE.CDHABILIDADE)
                      AND (RE.CDFILIAL = :CDFILIAL)
                      AND (RE.NRAUDITORIA = :NRAUDITORIA)
                      AND (RE.NRINSPECAUDI = :NRINSPECAUDI)
                      AND (RE.CDINSPECAO = :CDINSPECAO)
                      AND (A.CDETAPAPROD = :CDETAPAPROD)
                      AND (O.CDOPERADOR(+) = RE.CDOPERADOR)
                      AND (EQ.CDEQUIPPRO(+) = RE.CDEQUIPPRO)
                      AND (A.CDFILIAL = RQ.CDFILIAL(+))
                      AND (A.NRORDPROD = RQ.NRORDPROD(+))
                      AND (A.NRSUBORDPROD = RQ.NRSUBORDPROD(+))
                      AND (A.NRAUDITORIA = RE.NRAUDITORIA)
                      AND (A.CDETAPAPROD = RQ.CDETAPAPROD(+))
                      AND (EQ.CDGRUPOEQUIPA = GE.CDGRUPOEQUIPA(+))
                      AND (RE.NRRECURPAI IS NULL)
                    ORDER BY RE.NRRECUETAPOP,
                             RE.CDFILIAL,
                             RE.NRAUDITORIA,
                             RE.NRINSPECAUDI,
                             RE.NRORDUTRECOP";
            
            $params = array(
                'CDFILIAL'=>$filter['CDFILIAL'],
                'NRAUDITORIA'=>$filter['NRAUDITORIA'],
                'NRINSPECAUDI'=>$filter['NRINSPECAUDI'],
                'CDETAPAPROD'=>$filter['CDETAPAPROD'],
                'CDINSPECAO'=>$filter['CDINSPECAO']
            );
            
            $std = $this->connection->prepare($sql);
            $std->execute($params);
            return $std->fetchAll();
            
        }catch (\Exception $e) {
            throw $e;
        }
    }
}

?>