<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

use Teknisa\CDP\Controllers\TeknisaCrud;
use Teknisa\GER\Controllers\CrudController;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use \Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Teknisa\CDP\Modules\Producao\Services\cdp01500ParametrosMrpService;

class cdp01500ParametrosMrpController extends TeknisaCrud {
    protected $dataSourceName = 'paramprodmrp';
    protected $dataSourceNameToSave = '';
    protected $cdp01500ParametrosMrpService;

    public function __construct($crudService, ParameterBag $parameterBag, cdp01500ParametrosMrpService $cdp01500ParametrosMrpService){
        parent::__construct($crudService, $parameterBag);
        $this->cdp01500ParametrosMrpService = $cdp01500ParametrosMrpService;
    }
    
    public function maxNvProduto($request, $response){
        $maxNv = $this->cdp01500ParametrosMrpService->getMaxNvProduto();
        $dataSet = new DataSet('maxNvProduto', $maxNv);
        $response->addDataSet($dataSet);
    }
    
    public function saveParamMrp(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        
        try{
            if(!$row['__is_new']) {
                $this->cdp01500ParametrosMrpService->UpdateParametro($row);
    	    } else {
    	        parent::save($request, $response);
    	    }
        } catch(\Exception $e){
            $response->setError(new DTO\Response\Error($e->getMessage(),1));
        }
    }
}