<?php
namespace Teknisa\CDP\Modules\Producao\Controllers;

use DOMPDF;
use Doctrine\ORM\EntityManager;
use Teknisa\GER\Libraries\PHPMailer;
use Teknisa\CDP\Controllers\TeknisaCrud;
use Teknisa\GER\Controllers\CrudController;
use Teknisa\CDP\Modules\Producao\Services\cdpExtratoOrdemProducaoService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;

class cdpExtratoOrdemProducaoController extends TeknisaCrud{
    protected $parameterBagColumns = array();
    protected $newCode;
    protected $environment;
    protected $service;
    
    public function __construct($crudService, ParameterBag $parameterBag, $newCode,$environment, $service){
        
        $this->novoCodigo = $newCode;
        $this->environment = $environment;
        $this->parameterBag = $parameterBag;
        $this->service = $service;
        parent::__construct($crudService, $parameterBag);
        
    }
    
    public function geraRelatorio($request, DTO\Response $response){
        $row = $request->getDataSet()->getRows()[0];
        
        $dadosHeader = $this->service->buscaDadosHeader($row);
        $listaEtapas = $this->service->buscaListaEtapa($row);

        $html = '<html>
                    <style type="text/css">
                        #texto{
                            top:130px;
                            position: relative;
                            line-height: 1.2;
                        }                    
                    
                        #header{
                            position:fixed;
                            top:0px;
                            width: 100%;
                            text-align: center;
                            font-size: 50px;
                        }
                        
                        table {
                            
                            width:100%;
                            border-collapse: collapse;
                            border-spacing: 0;
                            margin: 0;
                        }
                        
                        table,th,td,tr{
                            border: 1px solid black;
                        }
                        
                        tbody,tr{
                            font: inherit;
                            font-size: 50px;
                            vertical-align: baseline;
                        }
                        
                        td{
                            padding: 8px;
                            text-align: justify;
                            font-size:13px;
                            line-height: 1;
                            
                        }
                        
                        .linhaMeio{
                            width:50%;
                            font-size: 14px;
                        }
                        
                        .ultimaLinha{
                            width:33%;!important;
                            font-size: 14px;
                        }
                    </style>
                    <body>
                        <div id="header">
                            <center style="font-size:15px;"><b>EXTRATO DE ORDEM DE PRODUÇÃO</b></center>
                            <table>
                                <tr>
                                    <td><b>Produto:</b> '.$dadosHeader[0]['CDARVPROD'].' - '.$dadosHeader[0]['NMPRODUTO'].'     <p style="margin-top:-21px;margin-left:82%;"><b>OP.:</b> '.$dadosHeader[0]['NRORDPROD'].'/ '.$dadosHeader[0]['NRSUBORDPROD'].'</p></td>
                                </tr>
                            </table>
                            <table style="border-top:0;border-bottom:0;">
                                <tr>
                                    <td style="width:50%;"><b>Data de Validade:</b>'.$dadosHeader[0]['DTVALILOTE'].'</td>
                                    <td style="width:50%;"><b>Quantidade a formular:</b>'.$dadosHeader[0]['QTAPRODPREOP'].'</td>
                                </tr>
                            </table>
                            <table>
                                <tr>
                                    <td style="width:30%;"><b>Lote:</b> '.$dadosHeader[0]['NRLOTEESTQ'].' </td>
                                    <td style="width:34.33%;"><b>Data de Inicialização:</b> '.$dadosHeader[0]['DTHRINIREAOP'].' </td>
                                    <td style="width:36.33%;"><b>Data de Fabricação:</b> '.$dadosHeader[0]['DTHRINICIAOP'].'</td>
                                </tr>
                            </table>
                        </div>
                        <div id="texto">';
                        for($i = 0; $i < count($listaEtapas); $i++){
                            $html .= '<div>
                                        <center><b>'.$listaEtapas[$i]['NMETAPAPROD'].'</b></center>
                                        <center style="margin-top:10px;"><b>Matéria Prima/Insumos</b></center>
                                        <table style="margin-bottom:0px;">
                                            <tr>
                                                <td><center><b>Código</b></center></td>
                                                <td><center><b>Matéria Prima/Insumos</b></center></td>
                                                <td><center><b>UN</b></center></td>
                                                <td><center><b>N.C</b></center></td>
                                                <td><center><b>Doseamento</b></center></td>
                                                <td><center><b>Qtde. Teórica</b></center></td>
                                                <td><center><b>Qtde. Corrigida</b></center></td>
                                            </tr>';
                            $listaInsumos = $this->service->buscaListaInsumo($row,$listaEtapas[$i]['CDETAPAPROD']);
                            for($j = 0; $j < count($listaInsumos); $j++){
                                $html .= '<tr>
                                            <td><center>'.$listaInsumos[$j]['CDARVPROD'].'</center></td>
                                            <td><center>'.$listaInsumos[$j]['NMPRODUTO'].'</center></td>
                                            <td><center>'.$listaInsumos[$j]['SGUNIDADE'].'</center></td>
                                            <td><center>'.$listaInsumos[$j]['NRLOTEESTQ'].'</center></td>';
                                            
                                            if($listaInsumos[$j]['VRAPROVPROD'] == null){
                                                $html .='<td><center>0</center></td>';
                                            }else{
                                                $html .='<td><center>'.$listaInsumos[$j]['VRAPROVPROD'].'</center></td>';
                                            }
                                            
                                            $html .='<td><center>'.$listaInsumos[$j]['QTDETEOR'].'</center></td>
                                            <td><center>'.$listaInsumos[$j]['QTDECOR'].'</center></td>
                                        </tr>';
                            }
                            $html .= '</table></div>';
                            $listaAtividades = $this->service->buscaAtividade($row,$listaEtapas[$i]['CDETAPAPROD']);
                            for($k = 0; $k < count($listaAtividades); $k++){
                                $html .= '<table style="margin-top:0px;">
                                            <tr>
                                                <td><b>Atividade</b></td>
                                                <td><b>Dt. Inicio</b></td>
                                                <td><b>Dt. Final</b></td>
                                                <td><b>Operador</b></td>
                                            </tr>
                                            <tr>
                                                <td>'.$listaAtividades[$k]['NMINSPECAO'].'</td>
                                                <td>'.$listaAtividades[$k]['DTINIRINSAUD'].'</td>
                                                <td>'.$listaAtividades[$k]['DTFINRINSAUD'].'</td>
                                                <td>'.$listaAtividades[$k]['NMOPERADOR'].'</td>
                                            </tr>
                                       </table><div>';
                                       $texto = str_replace("<br>", "", $listaAtividades[$k]['TXDESCINSPEC_CLOB']);
                                       $texto = str_replace("&nbsp;", "", $texto);
                                       $texto = str_replace("<p></p>", "", $texto);
                                       $html .= $texto.'</div>';
                                    //   var_dump(str_replace("<br>", "", $listaAtividades[$k]['TXDESCINSPEC_CLOB']));exit;
                            }
                            $listaPerdas = $this->service->buscaPerda($row,$listaEtapas[$i]['CDETAPAPROD']);
                            if(count($listaPerdas) != 0){
                                $html .= '<table>
                                            <tr>
                                                <td><b>Perda do Produto</b></td>
                                                <td><b>Perda no Equipamento</b></td>
                                                <td><b>Tipo de Perda</b></td>
                                                <td><b>Quantidade</b></td>
                                            </tr>';
                                for($l = 0 ; $l < count($listaPerdas); $l++){
                                     $html .= '<tr>
                                                <td>'.$listaPerdas[$l]['NMPRODUTO'].'</td>
                                                <td>'.$listaPerdas[$l]['NMEQUIPPRO'].'</td>
                                                <td>'.$listaPerdas[$l]['NMTIPOPERDA'].'</td>
                                                <td>'.$listaPerdas[$l]['QTPERDAOP'].'</td>
                                            </tr>';
                                       
                                }
                                
                                $html .= '</table>';
                            }
                            
                        }
        $html .= '</div></body></html>';
        
        $dompdf = new DOMPDF();
        $dompdf->load_html($html);
        $dompdf->render();
        $dompdf->set_paper("A4", "portrail");
        
        $pdf = $dompdf->output();
        $pdf = base64_encode($pdf);
        
        $response->addDataset(new DataSet('base64pdf', [$pdf]));
    }
    
    protected function processConditionValue($condition){
            return $condition['value'];
    }
    
    protected function populateParameterBag(FilterCriteria $filterCriteria){
    
        $conditions = array();
        foreach ($filterCriteria->getConditions() as $condition) {
            $columnName = $condition['columnName'];
            if (in_array($columnName, $this->parameterBagColumns)) {
                $this->parameterBag->set($columnName, $this->processConditionValue($condition));
            } else {
                $conditions[] = $condition;
            }
        }
        $newFilterCriteria = new FilterCriteria(
            $filterCriteria->getDataSourceName(),
            $conditions,
            $filterCriteria->getPage(),
            $filterCriteria->getPageSize()
        );
        return $newFilterCriteria;
        
    }
}

?>