<?php
namespace Teknisa\CDP\Modules\Producao\Services;

use Doctrine\ORM\EntityManager;
use Geral\Util\DateUtil;
use Teknisa\Libs\Util\Environment;


class Cdp04000AgendaDeTarefasService{

	protected $entityManager;
	protected $environment;
	protected $newCode;
	protected $Cdp04000AgendaDeTarefasFactory;

	public function __construct(Environment $environment, EntityManager $entityManager, $Cdp04000AgendaDeTarefasFactory){
		$this->environment				= $environment;
		$this->entityManager           = $entityManager;
		$this->Cdp04000AgendaDeTarefasFactory = $Cdp04000AgendaDeTarefasFactory;
	}

	
    public function deleteAgenda($rows){
            
        try{
        	$connection = $this->entityManager->getConnection();
            $connection->beginTransaction();
            
        	$this->Cdp04000AgendaDeTarefasFactory->deleteTabelaInspecao($rows['NRORG'],$rows['CDFILIAL'],$rows['CDSETOR'], $rows['CDPERIENTR'], $rows['HRAGENTARE'], $rows['IDORIGAGTARE']);
        	
        	$this->Cdp04000AgendaDeTarefasFactory->deleteTabelaAgenda($rows['NRORG'],$rows['CDFILIAL'],$rows['CDSETOR'], $rows['CDPERIENTR'], $rows['HRAGENTARE'], $rows['IDORIGAGTARE']);
        	
        	
        	$connection->commit();
        	
        }catch (\Exception $e) {
	        $this->entityManager->rollback();
	        throw $e;
	    }
        
    }
    
    public function UpdateAgenda($rows){
    	return $this->Cdp04000AgendaDeTarefasFactory->UpdateAgenda($rows['NRORG'],$rows['CDFILIAL'],$rows['CDSETOR'], $rows['CDPERIENTR'], $rows['HRAGENTARE'], $rows['IDORIGAGTARE'], $rows['CDEQUIPPRO'], $rows['DSAGENTARE'], $rows['BACKUP']);
    }

    public function verificaInspec($rows){
    	try{
        	$connection = $this->entityManager->getConnection();
    	    $connection->beginTransaction();
            
        	
        	$ExiteNaTabela = $this->Cdp04000AgendaDeTarefasFactory->verificaInspecao($rows['NRORG'], $rows['IDORIGAGTARE']);
    	
    	    if(empty($ExiteNaTabela)){
    	    	throw new \Exception('Não há inspeção cadastrada',1);
    	    }
    	}catch (\Exception $e) {
            $this->entityManager->rollback();
            throw $e;
        }
    }

}